import 'dart:convert' as jsonconverter;
import 'package:chopper/chopper.dart';
import 'package:tap_network_kit/src/interface/response_model_interface.dart';

class TapConverter<T extends ResponseModelInterface> extends JsonConverter {
  TapConverter(this.model);

  final T model;

  @override
  Request convertRequest(Request request) {
    return super.convertRequest(request.replace(body: (request.body).toJson()));
  }

  @override
  Response<BodyType> convertResponse<BodyType, InnerType>(
      Response<dynamic> response) {
        // print('TapConverter : response: ${response.body}');
    return response.replace<T>(
        body: model.fromJson(jsonconverter.json.decode(jsonconverter.utf8.decode(response.bodyBytes))));
  }
}
