import 'package:chopper/chopper.dart';
import 'package:tap_network_kit/src/retrofit/retrofit_helper.dart';
import 'package:tap_network_kit/tap_network_kit.dart';

/// Created by h.shestawy on "2019-07-16".
/// Copyright © "2019" Tap Payments. All rights reserved.
mixin APIService {
  // static ChopperClient client;

  /// wrap service with chopper client and send it back to the caller
  /// @param:     T can be any service of type Chopper service
  /// @return:    T service that has a Chopper client
  static T create<T extends ChopperService>(T _service, ResponseModelInterface jsonModel, String baseUrl) {
    _service.client = ChopperClient(
        baseUrl: baseUrl,
        interceptors: RetrofitHelper.getInterceptors(),
        converter: RetrofitHelper.getConverters(jsonModel),
        errorConverter: RetrofitHelper.getErrorConverter(),
        services: <ChopperService>[_service]);

    print('service : $_service');
    return _service;
  }
}
